From 3bd168a4232553a43ad09dbd8d47c384825496bd Mon Sep 17 00:00:00 2001
From: Eric Barbour <ebarbour@redhat.com>
Date: Jul 14 2016 14:40:39 +0000
Subject: [PATCH 536/1001] Move Feed to external SSE


---

diff --git a/hubs/app.py b/hubs/app.py
index c975952..7e24193 100755
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -639,76 +639,3 @@ def hub_leave(hub):
         return flask.abort(400)
     session.commit()
     return flask.redirect(flask.url_for('hub', name=hub.name))
-
-
-PATHS = fmn.lib.load_rules(root='fmn.rules')
-
-
-@app.route('/api/fedmsg/markup', methods=['GET'])
-def markup_fedmsg():
-    '''
-    This is a temporary endpoint to create a human-readable form of a message.
-    For now it serves as a development tool
-
-    This route will be removed once its functionality is integrated into FMN
-    '''
-    from hubs.widgets.feed import (
-        apply_markup, rehydrate_preference,
-        get_remote_preference
-    )
-    try:
-        data = flask.request.args['message']
-        plugin = flask.request.args['plugin']
-    except KeyError:
-        return flask.abort(400)
-
-    widget = hubs.models.Widget.by_plugin(session, plugin)
-
-    if not widget:
-        return flask.abort(400)
-
-    context = widget.config.get('fmn_context')
-
-    messages = []
-    message = json.loads(data)
-
-    if 'topic' not in message:
-        return flask.abort(400)
-
-    try:
-        nickname = flask.g.auth.nickname
-    except AttributeError:      # Not logged in
-        return flask.abort(403)
-
-    preference = get_remote_preference(nickname, context)
-
-    if preference:
-        try:
-            preference = rehydrate_preference(preference)
-        except ImportError:
-            pass
-    recipients = fmn.lib.recipients(
-        [preference], message, PATHS, fedmsg_config)
-    if recipients:
-        messages.append(message)
-    matches = fedmsg.meta.conglomerate(messages, lexers=True, **fedmsg_config)
-
-    for match in matches:
-        match['markup'] = apply_markup(match)
-        for _, constituent in match['msg_ids'].items():
-            constituent['markup'] = apply_markup(constituent)
-            if constituent['long_form'] != constituent['subtitle']:
-                if constituent.get('lexer'):
-                    constituent['long_form'] = pygments.highlight(
-                        constituent['long_form'],
-                        constituent['lexer'],
-                        pygments.formatters.HtmlFormatter(style='monokai'),
-                    )
-                else:
-                    markup = u"<h5>{long_form}</h5>".format(**constituent)
-                    constituent['long_form'] = markup
-
-        # And tack on a unique identifier for each top level entry.
-        match['dom_id'] = six.text_type(uuid.uuid4())
-
-    return flask.jsonify(matches)
diff --git a/hubs/static/client/app/components/Feed.jsx b/hubs/static/client/app/components/Feed.jsx
index 187a1d1..da00b25 100644
--- a/hubs/static/client/app/components/Feed.jsx
+++ b/hubs/static/client/app/components/Feed.jsx
@@ -12,11 +12,10 @@ import {Message, MessageList} from './Messages.jsx';
 class Panel extends React.Component {
   render() {
     return (
-      <div className="panel panel-default">
+      <div className="panel panel-default panel-visible">
         <div className="panel-body">
           <Icon match={this.props.match} />
           <Markup match={this.props.match} />
-          <Constituent match={this.props.match} />
         </div>
       </div>
     );
@@ -30,28 +29,22 @@ export default class Feed extends React.Component {
       matches: this.props.matches,
       sse: true,
     }
-    this.source = (!!window.EventSource) ? new EventSource('http://localhost:9090') : {};
+    this.source = (!!window.EventSource) ? new EventSource(this.props.url) : {};
     this.source.addEventListener('error', () => {
       this.state.sse = false;
     }, false);
     window.onbeforeunload = () => {
       this.source.close();
     }
-    this.source.addEventListener('message', resp => {
-      $.get('/api/fedmsg/markup', {
-        message: resp.data,
-        plugin: 'feed',
-      }).done(data => {
-        if(!$.isEmptyObject(data)) {
-          this.state.matches.push.apply(this.state.matches, data);
-          this.setState({matches: this.state.matches});
-        }
-      });
-    }, false);
+    this.source.onmessage = resp => {
+      const data = JSON.parse(resp.data);
+      this.state.matches.push(data);
+      this.setState({matches: this.state.matches});
+    };
   }
   render() {
     const feedNodes = this.state.matches.map(match => {
-      return <Panel match={match}/>
+      return <Panel match={match} />
     });
     return (
       <div>
@@ -61,7 +54,6 @@ export default class Feed extends React.Component {
   }
 }
 
-
 window.Feed = Feed;
 window.React = React;
 window.reactRender = render;
